/**
 * MMP 1
 * MultiMediaTechnology - FH Salzburg
 * Author: Felix Beer
 *
 * This shader was partly generated by ChatGPT but had to be modified to work properly
 */

uniform vec2 resolution;
uniform float opacity;

void main()
{
    vec2 uv = gl_FragCoord.xy / resolution.xy;

    // Define the area where the fog effect will be applied
    float fogStart = 0.0; // Adjust the value to control the fog height
    float fogEnd = 0.9;   // Adjust the value to control the fog density

    // Calculate the fog density based on the vertical position
    float fogDensity = smoothstep(fogStart, fogEnd, 1.0 - uv.y);

    // Calculate the transparency based on the fog density
    float transparency = (1.0 - fogDensity) * opacity;

    // Apply the fog effect to the color
    vec3 fogColor = vec3(0.9, 0.9, 0.9); // Adjust the color of the fog
    vec4 finalColor = vec4(fogColor, transparency);

    gl_FragColor = finalColor;
}
